import 'dart:async';

import 'package:flutter/services.dart';

class RouterPlugin {
  static const MethodChannel _channel = const MethodChannel('router_plugin');

  static const KEY_URL = "url";
  static const KEY_PARAMS = "params";

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<int> page(String url, [Map<String, dynamic> params]) async {
    try {
      Map<String, dynamic> map = Map();
      map[KEY_URL] = url;
      if (null != params) {
        map[KEY_PARAMS] = params;
      }
      return await _channel.invokeMethod('page', map);
    } on PlatformException catch (e) {
      print('RouterPlugin route page error $e');
      return -1;
    }
  }

  static Future<dynamic> method(String url,
      [Map<String, dynamic> params]) async {
    try {
      Map<String, dynamic> map = Map();
      map[KEY_URL] = url;
      if (null != params) {
        map[KEY_PARAMS] = params;
      }
      return await _channel.invokeMethod('method', map);
    } on PlatformException catch (e) {
      print('RouterPlugin route  method error $e');
      return null;
    }
  }
}
